%define sslver 1.0.0

%define major 2
%define libname %mklibname p11_ %{major}
%define devname %mklibname p11 -d

Summary:	Small library on top of PKCS#11
Name:		libp11
Version:	0.4.7
Release:	1
License:	LGPLv2+
Group:		System/Libraries
Url:		https://github.com/OpenSC/libp11
Source0:	http://www.opensc-project.org/files/libp11/%{name}-%{version}.tar.gz
BuildRequires:	libltdl-devel
BuildRequires:	pkgconfig(openssl)

%description
Libp11 is a library implementing a small layer on top of PKCS#11 API to make
using PKCS#11 implementations easier.

#----------------------------------------------------------------------------

%package -n engine_pkcs11
Summary:	PKCS#11 engine for OpenSSL
Group:		System/Libraries
Suggests:	opensc

%description -n engine_pkcs11
Engine_pkcs11 is an implementation of an engine for OpenSSL. It can be loaded
using code, config file or command line and will pass any function call by
openssl to a PKCS#11 module. Engine_pkcs11 is meant to be used with smart cards
and software for using smart cards in PKCS#11 format, such as OpenSC. Originaly
this engine was a part of OpenSC, until OpenSC was split into several small
projects for improved flexibility.

%files -n engine_pkcs11
%doc README.rosa
%{_libdir}/openssl-%{sslver}/engines/*.so

#----------------------------------------------------------------------------

%package -n %{libname}
Summary:	Library files for libp11
Group:		System/Libraries

%description -n %{libname}
This package contains library files for libp11.

%files -n %{libname}
%doc NEWS
%{_libdir}/libp11.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{devname}
Summary:	Development files for libp11
Group:		Development/C
Requires:	%{libname} = %{EVRD}
Provides:	%{name}-devel = %{EVRD}

%description -n %{devname}
This package contains files needed for development with libp11.

%files -n %{devname}
%{_libdir}/*.so
%{_libdir}/pkgconfig/libp11.pc
%{_includedir}/*

#----------------------------------------------------------------------------

%prep
%setup -q

cat > README.rosa <<EOF
In ROSA, the engine file has been placed in the
%{_libdir}/openssl-%{sslver}/engines directory instead of the default
%{_libdir}/engines. This was done so in order to match our openssl
installation.

Considering this new path, below is the suggested change to openssl.cnf
in order to use this engine:

openssl_conf = openssl_def

[openssl_def]
engines = engine_section

[engine_section]
pkcs11 = pkcs11_section

[pkcs11_section]
engine_id = pkcs11
dynamic_path = %{_libdir}/openssl-%{sslver}/engines/pkcs11.so
MODULE_PATH = %{_libdir}/opensc-pkcs11.so
init = 0

EOF

%build
%configure2_5x \
	--with-enginesdir=%{_libdir}/openssl-%{sslver}/engines/ \
	--disable-static
%make

%install
%makeinstall_std

rm -fr %{buildroot}%{_datadir}/doc


%changelog

* Tue Aug 08 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 0.4.7-1
- (3fd4061) Suggest opensc


